import gtk
from utils import *

class Menu:
    def __init__(self, app, tube_win_factory):
        self.app = app

        self.tube_win = None
        self.tube_win_factory = tube_win_factory

        self.about = None

    def menu(self):
        mb = gtk.MenuBar()
        for label, submenu in (
            ('Friend', self.friend_menu()),
            ('Help', self.help_menu()),
        ):
            sm = gtk.MenuItem(label=label)
            sm.set_submenu(submenu)
            mb.add(sm)
        return mb

    def friend_menu(self):
        menu = gtk.Menu()
        for item in (
            ('Tube diagnostics', self.tube_win_activate),
            #None, # separator
            ('Quit', cb_call(gtk.main_quit)),
        ):
            if item==None:
                menu.add(gtk.SeparatorMenuItem())
            else:
                text, callback = item
                mi = gtk.MenuItem(text)
                mi.connect("activate", callback)
                menu.add(mi)
        menu.show_all()
        return menu

    def help_menu(self):
        menu = gtk.Menu()
        for item in (
            ('About', self.about_box),
            #None, # separator
        ):
            if item==None:
                menu.add(gtk.SeparatorMenuItem())
            else:
                text, callback = item
                mi = gtk.MenuItem(text)
                mi.connect("activate", callback)
                menu.add(mi)
        menu.show_all()
        return menu

    def tube_win_activate(self, icon):
        if self.tube_win is None or self.tube_win.quitter is None:
            self.tube_win = self.tube_win_factory()
        elif self.tube_win.window.has_toplevel_focus():
            self.tube_win.close()
            self.tube_win = None
        else:
            self.tube_win.window.present()

    def about_box(self, arg):
        if self.about is not None:
            self.about.present()
            return

        def about_close(*args):
            self.about = None

        self.about = gtk.AboutDialog()
        self.about.set_name('connectr social network')
        #self.about.set_version(version)
        #self.about.set_copyright(copyright)
        #self.about.set_comments(comments)
        #self.about.set_license(license)
        #self.about.set_wrap_license(license)
        self.about.set_website('http://www.baum.com.au/connectr')
        #self.about.set_website_label(website_label)
        self.about.set_authors((u'Ji\u0159\u00ed Baum <jiri@baum.com.au>',))
        #self.about.set_documenters(documenters)
        #self.about.set_artists(artists)
        #self.about.set_translator_credits(translator_credits)
        #self.about.set_logo(logo)
        self.about.set_logo_icon_name('connectr')
        #self.about.set_program_name(name)

        self.about.connect('destroy', about_close)
        self.about.connect('response', lambda *args: self.about.destroy())
        self.about.show()

